//+------------------------------------------------------------------+
//|                                                    incMatrix.mq4 |
//|                                                                * |
//|                                                                * |
//+------------------------------------------------------------------+

#property copyright "Integer"
#property link      "http://www.mql4.com/ru/users/Integer"

/*

       .

       , :   ,   .. 
         :     .
   
   :
   
   double m[]={1,2,3,
               4,5,6,
               2,3}; //       .

    :

      void MxSetSize(double & aA[],int aRows,int aCols) -    aA, aRows -  , aCols -  ;
 
      void MxSetValue(double & aA[],int aRow,int aCol,double aValue) -   (Value)   aA,    aRow   aCol;
 
      int MxGetSize(double & aA[],int & aRows,int & aCols) -     aA,   : aRows -  , aCols -  ;
 
      int MxGetRows(double & aA[]) -     aA;
 
      int MxGetCols(double & aA[]) -     aA;
 
      double MxGetValue(double & aA[],int aRow,int aCol) -     aA,    aRow   aCol;
 
      void MxCopy(double & aFrom[],double & aTo[]) -     aFrom   aTo;
 
      bool MxCheckForAdd(double & aA[],double & aB[]) -         (     );
 
      bool MxCheckForMult(double & aA[],double & aB[]) -         (-   aA  -   aB);
 
      bool MxCheckIsSq(double & aA[]) -     ;
 
      void MxAddNum(double & aA[],double aNum,double & aR[]) -   aNum   aA,  ()     c aR;
 
      void MxMultNum(double & aA[],double aNum,double & aR[]) -   aA   aNum,       c aR;
 
      void MxAddMx(double & aA[],double & aB[],double & aAB[]) -   aA  aB,      aAB;
 
      void MxMultMx(double & aA[],double & aB[],double & aAB[]) -   aA   aB,      aAB;
 
      void MxT(double & aA[],double & aT[]) -   aA,       aT;
 
      void MxMxAA(double & aA[],double & aAA[]) -    . aA -  , aAA -   (  );
 
      bool MxB(double & aA[],double & aB[]) -      aB   aA,    true      false,     ;
 
      void MxTriangle(double & aA[],double & aT[]) -      aT   aA;
 
      void MxM(double aA[],int aRow,int aCol,double & aM[]) -     aA   aRow   aCol,       aM; 
 
      double MxDefM(double & aA[],int aRow,int aCol) -      aA   aRow   aCol;
 
      void MxMxM(double & aA[],double & aM[]) -    (    ). aA -  , aM -    (  );
 
      double MxDef(double & aA[]) -     aA;
 
      int MxRank(double & aA[]) -    aA;
 
      int MxRankDRC(double & aA[],double & aDef,int & aRow,int & aCol) -    aA    : aDef -  , aRow, aCol -         0;
 
      void MxCopyCol(double & aFrom[],double & aTo[],int aFromCol,int aToCol,double & aR[]) -     aFromCol   aFrom   aTo     aToCol,      aR;
 
      void MxCopyRow(double & aFrom[],double & aTo[],int aFromRow,int aToRow,double & aR[]) -     aFromRow   aFrom   aTo     aToRow,      aR;
 
      void MxAppendCol(double & aA[],double & aC[],double & aR[]) -   aA      aC,      aR;
 
      bool MxSystemKramer(double & aK[],double & aY[],double & aX[]) -     . a -   (), aY -  , aX -  ;
 
      bool MxSystemInverse(double & aK[],double & aY[],double & aX[]) -      . a -   (), aY -  , aX -  ;
 
      bool MxSystemGauss(double & aK[],double & aY[],double & aX[]) -     . a -   (), aY -  , aX -  ;
 
      int MxSystemCheck(double & aK[],double & aY[]) -   . a -   (), aY -  .  : -1 -  , 0 -  , 1 -   ;
 
      void MxAlert(double & aA[],int aDigits=2,string aCaption="") -      . aA - , aDigits -    , aCaption -  ;
 
      void MxAlert2(double & aA[],int aDigits=2,string aCaption="") -     ,    , , , ..      :  ,    ;
 
      void MxAlert1Str(double & aA[],int aDigits=2) -      .
*/


void MxSetSize(double & aA[],int aRows,int aCols){ //    aA, aRows -  , aCols -  
   int sz=aRows*aCols+2;
   ArrayResize(aA,sz);
   ArrayInitialize(aA,0);
   aA[sz-2]=aRows;
   aA[sz-1]=aCols;
}

void MxSetValue(double & aA[],int aRow,int aCol,double aValue){ //   (Value)   aA,    aRow   aCol
   aA[aRow*MxGetCols(aA)+aCol]=aValue;
}

int MxGetSize(double & aA[],int & aRows,int & aCols){ //     aA,   : aRows -  , aCols -  
   int sz=ArraySize(aA);
   sz-=2;
   aRows=aA[sz];
   aCols=aA[sz+1];
   return(sz);
}

int MxGetRows(double & aA[]){ //     aA
   return(aA[ArraySize(aA)-2]);
}

int MxGetCols(double & aA[]){ //     aA
   return(aA[ArraySize(aA)-1]);
}

double MxGetValue(double & aA[],int aRow,int aCol){ //     aA,    aRow   aCol
   return(aA[aRow*MxGetCols(aA)+aCol]);
}

void MxCopy(double & aFrom[],double & aTo[]){ //     aFrom   aTo
   ArrayResize(aTo,ArraySize(aFrom));
   ArrayCopy(aTo,aFrom,0,0,ArraySize(aFrom));
}

bool MxCheckForAdd(double & aA[],double & aB[]){ //         (     )
   int ARows,ACols,BRows,BCols;
   MxGetSize(aA,ARows,ACols);
   MxGetSize(aB,BRows,BCols);
   return(ARows==BRows && ACols==BCols);
}

bool MxCheckForMult(double & aA[],double & aB[]){ //         (-   aA  -   aB)
   return(MxGetCols(aA)==MxGetRows(aB));
}

bool MxCheckIsSq(double & aA[]){ //     
   int ARows,ACols;
   MxGetSize(aA,ARows,ACols);
   return(ARows==ACols);
}

void MxAddNum(double & aA[],double aNum,double & aR[]){ //   aNum   aA,  ()     c aR
   int sz=ArraySize(aA);
   ArrayResize(aR,sz);
   aR[sz-2]=aA[sz-2];
   aR[sz-1]=aA[sz-1];
      for(int i=ArraySize(aA)-3;i>=0;i--){
         aR[i]=aA[i]+aNum;
      }
}

void MxMultNum(double & aA[],double aNum,double & aR[]){ //   aA   aNum,       c aR
   int sz=ArraySize(aA);
   ArrayResize(aR,sz);
   aR[sz-2]=aA[sz-2];
   aR[sz-1]=aA[sz-1];
      for(int i=ArraySize(aA)-3;i>=0;i--){
         aR[i]=aA[i]*aNum;
      }
}

void MxAddMx(double & aA[],double & aB[],double & aAB[]){ //   aA  aB,      aAB
   int ARows,ACols,BRows,BCols,ABRows,ABCols;
   MxGetSize(aA,ARows,ACols);
   MxGetSize(aB,BRows,BCols);
   ABRows=MathMin(ARows,BRows);
   ABCols=MathMin(ACols,BCols);
   double tmp[];
   MxSetSize(tmp,ABRows,ABCols);
      for(int r=0;r<ABRows;r++){
         for(int c=0;c<ABCols;c++){
            int i=r*ABCols+c;
            tmp[i]=aA[i]+aB[i];
         }
      }
   MxCopy(tmp,aAB);      
}

void MxMultMx(double & aA[],double & aB[],double & aAB[]){ //   aA   aB,      aAB
   int ARows,ACols,BRows,BCols,ABRows,ABCols;
   MxGetSize(aA,ARows,ACols);
   MxGetSize(aB,BRows,BCols);   
   ABRows=ARows;
   ABCols=BCols;
   int N=MathMin(ACols,BRows);
   double tmp[];
   MxSetSize(tmp,ABRows,ABCols);
      for(int r=0;r<ABRows;r++){
         for(int c=0;c<ABCols;c++){
            double sum=0;
               for(int n=0;n<N;n++){
                  sum+=MxGetValue(aA,r,n)*MxGetValue(aB,n,c);
               }
            MxSetValue(tmp,r,c,sum);
         }
      }
   MxCopy(tmp,aAB);
}

void MxT(double & aA[],double & aT[]){ //   aA,       aT
   int ARows,ACols;
   MxGetSize(aA,ARows,ACols);
   double tmp[];
   MxSetSize(tmp,ACols,ARows);   
      for(int r=0;r<ARows;r++){
         for(int c=0;c<ACols;c++){
            double Val=MxGetValue(aA,r,c);
            MxSetValue(tmp,c,r,Val);
         }
      }   
   MxCopy(tmp,aT);
}

void MxMxAA(double & aA[],double & aAA[]){ //    . aA -  , aAA -   (  )
   int ARows,ACols;
   MxGetSize(aA,ARows,ACols);
   double tmp[];
   MxCopy(aA,tmp); 
      for(int r=0;r<ARows;r++){
         for(int c=0;c<ACols;c++){
            if((r+c)%2==1){
               double Val=MxGetValue(tmp,r,c);
               Val*=-1;
               MxSetValue(tmp,r,c,Val);
            }
         }
      }     
   MxCopy(tmp,aAA);
}

bool MxB(double & aA[],double & aB[]){ //      aB   aA,    true      false,     
   double D=MxDef(aA);
   if(D==0)return(false);
   D=1.0/D;
   double tmp[];
   MxMxM(aA,tmp);
   MxMxAA(tmp,tmp);   
   MxT(tmp,tmp);   
   MxMultNum(tmp,D,tmp);
   MxCopy(tmp,aB);
   return(true);
}

void MxTriangle(double & aA[],double & aT[]){ //      aT   aA
   double A[];
   MxCopy(aA,A);
   int Rows,Cols;
   MxGetSize(A,Rows,Cols);
      for(int r=0;r<Rows;r++){
         double vrr=MxGetValue(A,r,r);
            if(vrr==0){
                  for(int r2=r+1;r2<Rows;r2++){
                     if(MxGetValue(A,r2,r)!=0){
                        for(int c=0;c<Cols;c++){
                           double v=MxGetValue(A,r,c);
                           MxSetValue(A,r,c,MxGetValue(A,r2,c));
                           MxSetValue(A,r2,c,v);
                        }
                     }
                  }
               vrr=MxGetValue(A,r,r);
            }
            if(vrr!=0){
               for(r2=r+1;r2<Rows;r2++){
                  double vr0=MxGetValue(A,r2,r);
                  double d=(-1)*vr0/vrr;
                     for(c=0;c<Cols;c++){
                        double v0=MxGetValue(A,r,c);
                        double vr=MxGetValue(A,r2,c);
                        vr=vr+v0*d;
                        MxSetValue(A,r2,c,vr);
                     }
               }
            }
      }
   MxCopy(A,aT);      
}

void MxM(double & aA[],int aRow,int aCol,double & aM[]){ //     aA   aRow   aCol,       aM 
   int ARows,ACols;
   MxGetSize(aA,ARows,ACols);
   int MRows=ARows-1;
   int MCols=ACols-1;
   double tmp[];
   MxSetSize(tmp,MRows,MCols);
   int r,c; 
   double Val;
      for(r=0;r<aRow;r++){
         for(c=0;c<aCol;c++){
            Val=MxGetValue(aA,r,c);
            MxSetValue(tmp,r,c,Val);
         }   
         for(c=aCol;c<MCols;c++){
            Val=MxGetValue(aA,r,c+1);
            MxSetValue(tmp,r,c,Val);
         }           
      }
      for(r=aRow;r<MRows;r++){
         for(c=0;c<aCol;c++){
            Val=MxGetValue(aA,r+1,c);
            MxSetValue(tmp,r,c,Val);
         }   
         for(c=aCol;c<MCols;c++){
            Val=MxGetValue(aA,r+1,c+1);
            MxSetValue(tmp,r,c,Val);
         }           
      }  
   MxCopy(tmp,aM);
}

double MxDefM(double & aA[],int aRow,int aCol){ //      aA   aRow   aCol
   double tmp[];
   MxM(aA,aRow,aCol,tmp);
   return(MxDef(tmp));
}

void MxMxM(double & aA[],double & aM[]){ //    (    ). aA -  , aM -     (  )
   double tmp[];
   int ARows,ACols;
   MxGetSize(aA,ARows,ACols);
   MxSetSize(tmp,ARows,ACols);
      for(int r=0;r<ARows;r++){
         for(int c=0;c<ACols;c++){
            double mdef=MxDefM(aA,r,c);
            MxSetValue(tmp,r,c,mdef);
         }
      }
   MxCopy(tmp,aM);
}

double MxDef(double & aA[]){ //     aA
   double A[];
   MxCopy(aA,A);
   int Rows,Cols;
   MxGetSize(A,Rows,Cols);
   int MSize=MathMin(Rows,Cols);
   double Sn[];
   ArrayResize(Sn,MSize);
   ArrayInitialize(Sn,1);
      for(int s=0;s<MSize;s++){
         double v00=MxGetValue(A,s,s);
            if(v00==0){
                  for(int r=s+1;r<MSize;r++){
                     double vr0=MxGetValue(A,r,s);
                        if(vr0!=0){
                              for(int c=s;c<MSize;c++){
                                 double v1=MxGetValue(A,s,c);
                                 double v2=MxGetValue(A,r,c);
                                 MxSetValue(A,s,c,v2);
                                 MxSetValue(A,r,c,v1);
                              }
                           Sn[s]=-1;   
                           break;
                        }
                  }
               v00=MxGetValue(A,s,s);
                  if(v00==0){
                     return(0);
                  }
            }
            for(r=s+1;r<MSize;r++){
               double vr=MxGetValue(A,r,s);
               if(vr==0)continue;
               double d=(-1)*vr/v00;
                  for(c=0;c<MSize;c++){
                     double v0=MxGetValue(A,s,c);
                     vr=MxGetValue(A,r,c);
                     vr=vr+v0*d;
                     MxSetValue(A,r,c,vr);
                  }
            }
      }
   double def=1;      
      for(s=0;s<MSize;s++){
         def*=Sn[s]*MxGetValue(A,s,s);
      }
   return(def);      
}

int MxRank(double & aA[]){ //    aA
   double d;
   int r,c;
   return(MxRankDRC(aA,d,r,c));
}

int MxRankDRC(double & aA[],double & aDef,int & aRow,int & aCol){ //    aA    : aDef -  , aRow, aCol -         0
   int Rows,Cols;
   MxGetSize(aA,Rows,Cols);
   int MSize=MathMin(Rows,Cols);
   double A[];
      for(int s=MSize;s>0;s--){
         MxSetSize(A,s,s);
            for(int r=0;r<=Rows-s;r++){
               for(int c=0;c<=Cols-s;c++){
                     for(int r2=0;r2<s;r2++){
                        for(int c2=0;c2<s;c2++){
                           double v=MxGetValue(aA,r+r2,c+c2);
                           MxSetValue(A,r2,c2,v);
                        }
                     }
                  aDef=MxDef(A);
                     if(aDef!=0){
                        aRow=r;
                        aCol=c;
                        return(s);
                     }                  
               }
            }
      }      
   return(0);
}

void MxCopyCol(double & aFrom[],double & aTo[],int aFromCol,int aToCol,double & aR[]){ //     aFromCol   aFrom   aTo     aToCol,      aR
   int FromRows=MxGetRows(aFrom);
   int ToRows=MxGetRows(aTo);
   int Rows=MathMin(FromRows,ToRows);
   double tmp[];
   MxCopy(aTo,tmp); 
      for(int r=0;r<Rows;r++){
         double Val=MxGetValue(aFrom,r,aFromCol);
         MxSetValue(tmp,r,aToCol,Val);
      }
   MxCopy(tmp,aR);
}

void MxCopyRow(double & aFrom[],double & aTo[],int aFromRow,int aToRow,double & aR[]){ //     aFromRow   aFrom   aTo     aToRow,      aR
   int FromCols=MxGetCols(aFrom);
   int ToCols=MxGetCols(aTo);
   int Cols=MathMin(FromCols,ToCols);
   double tmp[];
   MxCopy(aTo,tmp); 
      for(int c=0;c<Cols;c++){
         double Val=MxGetValue(aFrom,aFromRow,c);
         MxSetValue(tmp,aToRow,c,Val);
      }
   MxCopy(tmp,aR);
}

void MxAppendCol(double & aA[],double & aC[],double & aF[]){ //   aA      aC,      aF
   int Rows,Cols;
   MxGetSize(aA,Rows,Cols);
   double tmp[];
   MxSetSize(tmp,Rows,Cols+1);
      for(int r=0;r<Rows;r++){
         for(int c=0;c<Cols;c++){
            MxSetValue(tmp,r,c,MxGetValue(aA,r,c));
         }
      }
   Rows=MathMin(Rows,MxGetRows(aC));
      for(r=0;r<Rows;r++){
         MxSetValue(tmp,r,Cols,MxGetValue(aC,r,0));
      }  
   MxCopy(tmp,aF);
}

void MxAppendRow(double & aA[],double & aR[],double & aF[]){ //   aA      aR,      aF
   int Rows,Cols;
   MxGetSize(aA,Rows,Cols);
   double tmp[];
   MxSetSize(tmp,Rows+1,Cols);
      for(int r=0;r<Rows;r++){
         for(int c=0;c<Cols;c++){
            MxSetValue(tmp,r,c,MxGetValue(aA,r,c));
         }
      }
   Cols=MathMin(Cols,MxGetCols(aR));
      for(c=0;c<Cols;c++){
         MxSetValue(tmp,Rows,c,MxGetValue(aR,0,c));
      }  
   MxCopy(tmp,aF);
}

bool MxSystemKramer(double & aK[],double & aY[],double & aX[]){ //     . a -   (), aY -  , aX -  
   double def=MxDef(aK);
   if(def==0)return(false);
   int KRows,KCols;
   MxGetSize(aK,KRows,KCols);
   int Size=MathMin(KRows,KCols);
   int YRows=MxGetRows(aY);
   Size=MathMin(Size,YRows);
   MxSetSize(aX,Size,1);
   double tmp[];
      for(int c=0;c<Size;c++){
         MxCopyCol(aY,aK,0,c,tmp);      
         aX[c]=MxDef(tmp)/def;
      }
   return(true);
} 

bool MxSystemInverse(double & aK[],double & aY[],double & aX[]){ //      . a -   (), aY -  , aX -  
   double B[];
   if(!MxB(aK,B))return(false);
   MxMultMx(B,aY,aX);
   return(true);
}

bool MxSystemGauss(double & aK[],double & aY[],double & aX[]){ //     . a -   (), aY -  , aX -  
   double K[];
   MxAppendCol(aK,aY,K);
   MxTriangle(K,K);
   int Rows,Cols;
   MxGetSize(K,Rows,Cols);
   MxSetSize(aX,Rows,1);
      for(int r=Rows-1;r>=0;r--){
         double y=MxGetValue(K,r,Cols-1);
         double k=MxGetValue(K,r,r);
            if(k==0){
               return(false);
            }
         double x=y/k;
         MxSetValue(aX,r,0,x);
            for(int r2=r-1;r2>=0;r2--){
               k=MxGetValue(K,r2,r);
               y=MxGetValue(K,r2,Cols-1);
               y-=k*x;
               MxSetValue(K,r2,Cols-1,y);
            }
      }
   return(true);
}

int MxSystemCheck(double & aK[],double & aY[]){ //   . a -   (), aY -  .  : -1 -  , 0 -  , 1 -   
   int r0=MxRank(aK);
   double K[];
   MxAppendCol(aK,aY,K);   
   int r1=MxRank(K);
      if(r0!=r1){
         return(-1); //  
      }
   int Rows,Cols;
   MxGetSize(aK,Rows,Cols);   
   int r3=MathMin(Rows,Cols);
      if(r1!=r3){
         return(1); //           
      }
   return(0); //        
   
}

void MxAlert(double & aA[],int aDigits=2,string aCaption=""){ //      . aA - , aDigits -    , aCaption -  
   int ARows,ACols;
   MxGetSize(aA,ARows,ACols);
   string str="=== === "+aCaption+" === ===\n";
      for(int r=0;r<ARows;r++){
            for(int c=0;c<ACols;c++){
               string tstr=DoubleToStr(MxGetValue(aA,r,c),aDigits);
               str=str+tstr+", ";
            }
         str=StringSubstr(str,0,StringLen(str)-2);
         str=str+"\n";
      }
   Alert(str);      
}

void MxAlert2(double & aA[],int aDigits=2,string aCaption=""){ //     ,    , , , ..      :  ,    .
   int ARows,ACols;
   MxGetSize(aA,ARows,ACols);
      for(int r=ARows-1;r>=0;r--){
         string str="";      
            for(int c=0;c<ACols;c++){
               str=str+DoubleToStr(MxGetValue(aA,r,c),aDigits)+", ";
            }
         str=StringSubstr(str,0,StringLen(str)-2);
         Alert(str);
      }
   Alert("=== === "+aCaption+" === ===");
}

void MxAlert1Str(double & aA[],int aDigits=2){ //      
   string str="";
      for(int i=0;i<ArraySize(aA);i++){
         str=str+DoubleToStr(aA[i],aDigits)+", ";
      }
      if(str!=""){
         str=StringSubstr(str,StringLen(str)-2);
      }         
   Alert(str);      
}